Package org.apache.storm.topology

## Class CheckpointTupleForwarder

- java.lang.Object
- - org.apache.storm.topology.BaseStatefulBoltExecutor
  - - org.apache.storm.topology.CheckpointTupleForwarder

- All Implemented Interfaces:
    `Serializable`, `IBolt`, `IComponent`, `IRichBolt`

      public class CheckpointTupleForwarder
      extends BaseStatefulBoltExecutor

  Wraps `IRichBolt` and forwards checkpoint tuples in a stateful topology.

  When a storm topology contains one or more `IStatefulBolt` all non-stateful bolts are wrapped in `CheckpointTupleForwarder` so that the checkpoint tuples can flow through the entire topology DAG.

  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.storm.topology.BaseStatefulBoltExecutor

      `BaseStatefulBoltExecutor.AnchoringOutputCollector`

  - ### Field Summary

    - ### Fields inherited from class org.apache.storm.topology.BaseStatefulBoltExecutor

      `collector`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `CheckpointTupleForwarder​(IRichBolt bolt)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `cleanup()` | Called when an IBolt is going to be shutdown.
    `void` | `declareOutputFields​(OutputFieldsDeclarer declarer)` | Declare the output schema for all the streams of this topology.
    `Map<String,​Object>` | `getComponentConfiguration()` | Declare configuration specific to this component.
    `protected void` | `handleCheckpoint​(Tuple checkpointTuple, CheckPointState.Action action, long txid)` | Forwards the checkpoint tuple downstream.
    `protected void` | `handleTuple​(Tuple input)` | Hands off tuple to the wrapped bolt to execute.
    `void` | `prepare​(Map<String,​Object> topoConf, TopologyContext context, OutputCollector outputCollector)` | Called when a task for this component is initialized within a worker on the cluster.

    - ### Methods inherited from class org.apache.storm.topology.BaseStatefulBoltExecutor

      `declareCheckpointStream, execute, init`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### CheckpointTupleForwarder

          public CheckpointTupleForwarder​(IRichBolt bolt)

  - ### Method Detail

    - #### prepare

          public void prepare​(Map<String,​Object> topoConf,
                              TopologyContext context,
                              OutputCollector outputCollector)

      Description copied from interface: `IBolt`
      Called when a task for this component is initialized within a worker on the cluster. It provides the bolt with the environment in which the bolt executes.

      This includes the:

      Parameters:
        `topoConf` - The Storm configuration for this bolt. This is the configuration provided to the topology merged in with cluster configuration on this machine.
        `context` - This object can be used to get information about this task's place within the topology, including the task id and component id of this task, input and output information, etc.
        `outputCollector` - The collector is used to emit tuples from this bolt. Tuples can be emitted at any time, including the prepare and cleanup methods. The collector is thread-safe and should be saved as an instance variable of this bolt object.

    - #### cleanup

          public void cleanup()

      Description copied from interface: `IBolt`
      Called when an IBolt is going to be shutdown. Storm will make a best-effort attempt to call this if the worker shutdown is orderly. The `Config.SUPERVISOR_WORKER_SHUTDOWN_SLEEP_SECS` setting controls how long orderly shutdown is allowed to take. There is no guarantee that cleanup will be called if shutdown is not orderly, or if the shutdown exceeds the time limit.

      The one context where cleanup is guaranteed to be called is when a topology is killed when running Storm in local mode.

    - #### declareOutputFields

          public void declareOutputFields​(OutputFieldsDeclarer declarer)

      Description copied from interface: `IComponent`
      Declare the output schema for all the streams of this topology.
      Parameters:
        `declarer` - this is used to declare output stream ids, output fields, and whether or not each output stream is a direct stream

    - #### getComponentConfiguration

          public Map<String,​Object> getComponentConfiguration()

      Description copied from interface: `IComponent`
      Declare configuration specific to this component. Only a subset of the "topology.*" configs can be overridden. The component configuration can be further overridden when constructing the topology using `TopologyBuilder`

    - #### handleCheckpoint

          protected void handleCheckpoint​(Tuple checkpointTuple,
                                          CheckPointState.Action action,
                                          long txid)

      Forwards the checkpoint tuple downstream.
      Specified by:
        `handleCheckpoint` in class `BaseStatefulBoltExecutor`
      Parameters:
        `checkpointTuple` - the checkpoint tuple
        `action` - the action (prepare, commit, rollback or initstate)
        `txid` - the transaction id.

    - #### handleTuple

          protected void handleTuple​(Tuple input)

      Hands off tuple to the wrapped bolt to execute.

      Right now tuples continue to get forwarded while waiting for checkpoints to arrive on other streams after checkpoint arrives on one of the streams. This can cause duplicates but still at least once.

      Specified by:
        `handleTuple` in class `BaseStatefulBoltExecutor`
      Parameters:
        `input` - the input tuple